# -*- coding: utf-8 -*-
#Comando para instalar PYINSTALLER
#pip install pyinstaller
#para generar el instalador debe pararse desde CMD en la carpeta rai del archivo
#con el comando -- pyinstaller NombreArchvico.py -- y se creara el ejecutable dentro de la carpeta dist
#Para aparecer solo la aplicacion sin la consula se debe adicionar
#al comando -- pyinstaller --windowed NombreArchivo.py y se debe eliminar cualquier archivo anteriormente creado
#Para que se genere un solo archivo se debe adicionar otro modificardor
# pyinstaller --windowed --onefile NombreArchivo.py

#COMANDO COMPLETO QUE FUNCIONA pero no compacta en un solo archivo
#pyinstaller --add-data "C:\Users\BOBLEHS\Documents\Python\CURSO_1_Beginner\TEORIA\pyinstaller\Imagen";"Imagen" --windowed Aplicacion_Calculadora.py



from tkinter import *

raiz=Tk()
#raiz.geometry("330x380")#ancho x alto
raiz.resizable(0,0)#no permite mover la raiz con el mouse
raiz.title("Calculadora de Hugo")
miFrame=Frame(width=1200,height=600)
miFrame.pack()#ipady e ipadx sirven para cambiar tamano interno de cuadros
miFrame.grid(padx=15,pady=15)#-column, -columnspan, -in, -ipadx, -ipady, -padx, -pady, -row, -rowspan, or -sticky
miFrame.config(width="280",height="300",relief="ridge",bg="white",bd=10)#sunken
operacion=""
resultado=float(0)
decimal=0
oper=""
reset_pantalla=False
numeroPantalla=StringVar()
seleccionOperador=StringVar()
validado=0
#------------------pantalla--------------------------------ipady e ipadx sirven para cambiar tamano interno de cuadros
pantalla=Entry(miFrame,textvariable=numeroPantalla,width="14")#Width da el No de digitos y es a la inversa del tamano de la fuente(tamano de letra)
pantalla.grid(row=1,column=1,ipady=15,padx=10,pady=10,columnspan=4)#columnspan hace que un elemento ocuoe un determinado # de columnas
pantalla.config(relief="sunken",bd=5,background="black",fg="#03f943",font=("Verdana",22),justify="right")#fondo negro , letras verde, ustificado a la derecha

#----------------Label de operador-------------------------

marcacion=Label(miFrame)
marcacion.grid(row=1,column=5,padx=1,pady=10,sticky="w")
marcacion.config(text="",fg="black",width=4,font=("Arial",16),justify="left")

#----------------------BORRAR TODO EN MEMORIA----------

def limpiarPantalla():
    global resultado,oper,decimal,reset_pantalla
    numeroPantalla.set("0")
    resultado=float(0)
    oper=""
    decimal=0
    reset_pantalla=False
    marcacion.config(text="",fg="black",justify="right")

#-----------------------Borra Numero----------------------

def borrarNumero():#borra el numero que se esta digitando
    global decimal
    numeroPantalla.set("0")
    decimal=0

#----------------Retroceder---------------------------

def retroceder():#borra el ultimo caracter digitado
    aBorrar=numeroPantalla.get()
    contar=int(len(aBorrar))-1
    aBorrar2=aBorrar[0:contar]
    aBorrar=aBorrar2
    numeroPantalla.set(aBorrar)

#-----------------Indicador de Miles

def indicardorMiles(num):
    pass


#--------------Pulsaciones Pantalla----------------------

def numeroPulsado(num):#fun para verificar tecla digitada
    divisionXcero=False
    global operacion,oper,decimal,resultado,contardecimal,reset_pantalla
    if oper=="hecho":#despues de presinar = en la calculadora, inicia estado de la calculadora con nuevos datos
        numeroPantalla.set(num)
        if num==".":
            numeroPantalla.set("0"+num)
            decimal=1
        else:
            decimal=0
            numeroPantalla.set(num)
        oper=""
        operacion=""
        marcacion.config(text="",fg="black",justify="right")
    elif operacion!="":# valida cualquier operacion anterior para iniciar nuevo numero con decimales o numero nuevo
        numeroPantalla.set(num)
        if num==".":
            numeroPantalla.set("0"+num)
            decimal=1
        else:
            decimal=0
            numeroPantalla.set(num)
        operacion=""
    elif num==".":#si se oprime el decimal verifica si hay o no un decimal, si lo hay no lo agrega
        if decimal<1:
            numeroPantalla.set(numeroPantalla.get()+num)
            decimal+=1
        else:
            numeroPantalla.set(numeroPantalla.get())
    elif num=="=":#imprime el resultado, devuelve variable que indica que se uso la tecla =
        var1=numeroPantalla.get()
#        print(var1,"Imprimer var1 en comando =")
        if divisionXcero and oper=="division":
            numeroPantalla.set("Resultado Indefinido en toalizado antes de todo")
            divisionXcero=False
        else:
            var1=noDecimales(numeroPantalla.get())
            if type(var1)==float:
                reset_pantalla=True
            elif type(resultado)==float:
                reset_pantalla=True
            totalizado()
        oper="hecho"
        reset_pantalla=False
    elif numeroPantalla.get()=="0" or numeroPantalla.get()=="00":
        if num==".":
            numeroPantalla.set("0"+num)
            decimal+=1
        elif oper=="division":
            divisionXcero=True
#            numeroPantalla.set(num)
        else:
            numeroPantalla.set(num)
    else:#sino se cumplen ninugna de las condiones indica que son numero y sugue concatenando
        numeroPantalla.set(numeroPantalla.get()+num)

#--------------------CMABIO DE SIGNO-------
def cambioSigno():
    global resultado,operacion,oper
    temp=numeroPantalla.get()
    temp2=str(temp)
    for i in temp2:
        if temp2.count(".")!=0:
            temp3=float(temp)*-1
        else:
            temp3=int(temp)*-1
    temp=str(temp3)
    numeroPantalla.set(temp)
#-------------------SUMA---------------

def suma(num):
    global operacion,resultado,decimal,oper,reset_pantalla
    operacion="suma"
    var2=str(resultado)
    temp2=numeroPantalla.get()
    temp=str(temp2)
    if temp.count(".")!=0 or var2.count(".")==1:
        if oper=="suma":
            resultado=noDecimales(float(resultado)+float(num))
#            oper=operacion
        else:
            temp=totalizado()#con decimal
            resultado=numeroPantalla.get()
#            oper=operacion
        reset_pantalla=True
    else:
        if oper=="suma":
            resultado=int(resultado)+int(num)
#            oper=operacion
        else:
            totalizado()#suma sin decimales
            conversor=numeroPantalla.get()
            if conversor.count(".")==1:
                resultado=conversor
                reset_pantalla=True
            else:
                resultado=int(conversor)
                reset_pantalla=False
    oper=operacion
    numeroPantalla.set(resultado)
    marcacion.config(text="+",fg="black",justify="right")

#-----------------Resta---------------------

def resta(num):
    global operacion,resultado,decimal,oper,reset_pantalla
    operacion="resta"
    var2=str(resultado)
    temp2=numeroPantalla.get()
    temp=str(temp2)
    if temp.count(".")!=0 or var2.count(".")==1:
        if oper=="resta":
            resultado=noDecimales(float(resultado)-float(num))
            oper=operacion
        elif resultado==0:
            resultado=noDecimales(num)
            oper=operacion
        else:
            totalizado()#resta con decimal
            resultado=numeroPantalla.get()
            oper=operacion
        reset_pantalla=True
    else:
        if oper=="resta":#resta sin decimal
            resultado=int(resultado)-int(num)
            oper=operacion
        elif resultado==0:
            resultado=int(num)
            oper=operacion
        else:
            totalizado()
            oper=operacion
            conversor=numeroPantalla.get()
            if conversor.count(".")==1:
                resultado=conversor
                reset_pantalla=True
            else:
                resultado=int(conversor)
                reset_pantalla=False
    numeroPantalla.set(resultado)
    marcacion.config(text="-",fg="black",justify="right")

#-----------------Multiplicacion---------------------

def multi(num):
    global operacion,resultado,decimal,oper,reset_pantalla
    operacion="multiplicacion"
    var2=str(resultado)
    temp2=numeroPantalla.get()
    temp=str(temp2)
    if temp.count(".")!=0 or var2.count(".")==1:
        if oper=="multiplicacion":
            resultado=noDecimales(float(resultado)*float(num))
            oper=operacion
        elif resultado==0:
            resultado=noDecimales(num)
            oper=operacion
        else:
            totalizado()#multiplicacion con decimal
            oper=operacion
            resultado=numeroPantalla.get()
        reset_pantalla=True
    else:
        if oper=="multiplicacion":
            resultado=int(resultado)*int(num)
            oper=operacion
            reset_pantalla=False
        elif resultado==0:
            resultado=int(num)
            oper=operacion
            reset_pantalla=False
        else:
            print (resultado)
            totalizado()#multiplicacion sin decimal
            oper=operacion
            conversor=numeroPantalla.get()
            if conversor.count(".")==1:
                resultado=conversor
                reset_pantalla=True
            else:
                resultado=int(conversor)
                reset_pantalla=False
    numeroPantalla.set(resultado)
    marcacion.config(text="x",fg="black",justify="right")

#-----------------Division---------------------

def division(num):
    global reset_pantalla,operacion,resultado,decimal,oper
    operacion="division"
    var2=str(resultado)
    temp2=numeroPantalla.get()
    temp=str(temp2)
    if temp.count(".")!=0 or var2.count(".")==1:#valida si hay decimales en lo que hay actualmente en pantalla
        if oper=="division":
            if num=="0.0" or float(num)==0.0:
                numeroPantalla.set("Resultado Indefinido")
            else:
                resultado=noDecimales(float(resultado)/float(num))
                oper=operacion
                numeroPantalla.set(resultado)
        elif resultado==0:
            resultado=noDecimales(num)
            oper=operacion
            numeroPantalla.set(resultado)
        else:
            totalizado()#division con decimal
            resultado=numeroPantalla.get()
            conversor=str(resultado)
            oper=operacion
            if conversor=="Resultado indefinido":
                numeroPantalla.set(conversor)
            else:
                numeroPantalla.set(resultado)
        reset_pantalla=True

    else:#si no hay decimal, hace operacion con enteros y retorna valor entero
        if oper=="division":
            if int(num)==0 or num=="0.0" or float(num)==0.0:
                numeroPantalla.set("Resultado Indefinido")
            else:
                resultado=noDecimales(int(resultado)/int(num))
                oper=operacion
                numeroPantalla.set(resultado)
        elif resultado==0:
            resultado=noDecimales(num)
            oper=operacion
            numeroPantalla.set(resultado)
        else:
            totalizado()#division sin decimal
            oper=operacion
            resultado=numeroPantalla.get()
            conversor=str(resultado)
            if conversor=="Resultado indefinido":
                resultado=conversor
                numeroPantalla.set(conversor)
            else:
                resultado=int(conversor)
                numeroPantalla.set(resultado)
        reset_pantalla=False
    marcacion.config(text="÷",fg="black",justify="right")


#-----------------------Borra decimales no necesarios
def noDecimales(borrarDecimal):
    global validado
    validado=(borrarDecimal)
    verificar=str(validado)
    if verificar.count(".")!=0:
        decas=verificar.split(".")#Separacion de numeros decimales
        if len(decas)==2:
            if decas[1]=="0":
                validado=int(decas[0])
            else:
                validado=float(verificar)
        else:
            validado=int(verificar)
    else:
        validado=int(verificar)
    return validado

#--------------Totalizado---------------------------------

def totalizado():
    sinDecas=0
    temp3=0
    temp4=0
    global validado,resultado,contardecimal,operacion,oper,decimal,reset_pantalla
    temp3=numeroPantalla.get()
    if (float(temp3)==0.0 or temp3=="0.0")and (oper=="division"):
        numeroPantalla.set("Resultado Indefinido")
    else:
        var2=str(resultado)
        temp3=noDecimales(numeroPantalla.get())
        if type(temp3)==float:#revisar este punto por qu eno esta trabajando bien
            temp4=float(temp3)
            reset_pantalla=True
        else:
            temp4=int(temp3)
        if reset_pantalla or var2.count(".")==1:
            if oper=="suma":
                sinDecas=noDecimales(float(resultado)+float(temp4))
                numeroPantalla.set(sinDecas)
            elif oper=="resta":
                sinDecas=noDecimales(float(resultado)-float(temp4))
                numeroPantalla.set(sinDecas)
            elif oper=="multiplicacion":
                sinDecas=noDecimales(float(resultado)*float(temp4))
                numeroPantalla.set(sinDecas)
            elif oper=="division":
                sinDecas=noDecimales(float(resultado)/float(temp4))
                numeroPantalla.set(sinDecas)
        else:
            if oper=="suma":
                sinDecas=noDecimales(int(resultado)+int(temp4))
                numeroPantalla.set(sinDecas)
            elif oper=="resta":
                sinDecas=noDecimales(int(resultado)-int(temp4))
                numeroPantalla.set(sinDecas)
            elif oper=="multiplicacion":
                sinDecas=noDecimales(int(resultado)*int(temp4))
                numeroPantalla.set(sinDecas)
            elif oper=="division":
                sinDecas=noDecimales(int(resultado)/int(temp4))#va a validar si decimal es igual a cero para retornar numero entero
                numeroPantalla.set(sinDecas)
    resultado=float(0)
    decimal=0
    marcacion.config(text="=",fg="black",justify="right")
numeroPantalla.set("0")
#----------------tamano botones
ancho_botones=5
largo_botones=2
borde_boton="raised"
tamanoBorde=3
tamanoFuente=("Verdana",12)
color_botones="#EEF0F0"#"gray77"
#-----------------Botones superiores-----Fila 1--------------

botonBorrarNum=Button(miFrame,text="CE",bg=color_botones,font=tamanoFuente,width=ancho_botones,height=largo_botones,relief=borde_boton,bd=tamanoBorde,command=borrarNumero)
botonBorrarNum.grid(row=2,column=1)
botonBorrarT=Button(miFrame,text="C",bg=color_botones,font=tamanoFuente,width=ancho_botones,height=largo_botones,relief=borde_boton,bd=tamanoBorde,command=limpiarPantalla)
botonBorrarT.grid(row=2,column=2)
#--Carga foto en boton retroceder
imagenRetro=PhotoImage(file="./Imagen/Retroceder.png")#llama y carga la imagen
#photo2=imagenRetro.subsample(1,1)#Entre mas grande los parametros mas pequena la imagen
#compound sirve para ubicr foto al lado de un texto o llevar la image a una posicion dentro del frame
botonRetroceder=Button(miFrame,text="Borrar",image=imagenRetro,bg=color_botones,font=("Verdana",6),compound=LEFT,width=52,height=42,relief=borde_boton,bd=tamanoBorde,command=retroceder)
botonRetroceder.grid(row=2,column=3,sticky="n")
#imagenRetro=PhotoImage(file="Retroceder.png")
#Label(botonRetroceder,image=imagenRetro,).pack()



botonCambioSigno=Button(miFrame,text="+/-",font=tamanoFuente,bg=color_botones,width=ancho_botones,height=largo_botones,relief=borde_boton,bd=tamanoBorde,command=cambioSigno)
botonCambioSigno.grid(row=2,column=4)



#-----------------Botones superiores Secundarios-----Fila 2--------------

boton7=Button(miFrame,text="7",font=tamanoFuente,bg=color_botones,width=ancho_botones,height=largo_botones,relief=borde_boton,bd=tamanoBorde,command=lambda:numeroPulsado("7"))
boton7.grid(row=3,column=1)
boton8=Button(miFrame,text="8",font=tamanoFuente,bg=color_botones,width=ancho_botones,height=largo_botones,relief=borde_boton,bd=tamanoBorde,command=lambda:numeroPulsado("8"))
boton8.grid(row=3,column=2)
boton9=Button(miFrame,text="9",font=tamanoFuente,bg=color_botones,width=ancho_botones,height=largo_botones,relief=borde_boton,bd=tamanoBorde,command=lambda:numeroPulsado("9"))
boton9.grid(row=3,column=3)
botonDiv=Button(miFrame,text="/",font=tamanoFuente,bg=color_botones,width=ancho_botones,height=largo_botones,relief=borde_boton,bd=tamanoBorde,command=lambda:division(numeroPantalla.get()))
botonDiv.grid(row=3,column=4)
botonIgual=Button(miFrame,text="=",font=tamanoFuente,bg=color_botones,width=ancho_botones,height=7,relief=borde_boton,bd=tamanoBorde,command=lambda:numeroPulsado("="))
botonIgual.grid(row=3,column=5,rowspan=4)

#-----------------Botones intermedios superiores-----Fila 2--------------

boton4=Button(miFrame,text="4",font=tamanoFuente,bg=color_botones,width=ancho_botones,height=largo_botones,relief=borde_boton,bd=tamanoBorde,command=lambda:numeroPulsado("4"))
boton4.grid(row=4,column=1)
boton5=Button(miFrame,text="5",font=tamanoFuente,bg=color_botones,width=ancho_botones,height=largo_botones,relief=borde_boton,bd=tamanoBorde,command=lambda:numeroPulsado("5"))
boton5.grid(row=4,column=2)
boton6=Button(miFrame,text="6",font=tamanoFuente,bg=color_botones,width=ancho_botones,height=largo_botones,relief=borde_boton,bd=tamanoBorde,command=lambda:numeroPulsado("6"))
boton6.grid(row=4,column=3)
botonMulti=Button(miFrame,text="*",font=tamanoFuente,bg=color_botones,width=ancho_botones,height=largo_botones,relief=borde_boton,bd=tamanoBorde,command=lambda:multi(numeroPantalla.get()))
botonMulti.grid(row=4,column=4)

#-----------------Botones intermedios inferiores-----Fila 3--------------

boton1=Button(miFrame,text="1",font=tamanoFuente,bg=color_botones,width=ancho_botones,height=largo_botones,relief=borde_boton,bd=tamanoBorde,command=lambda:numeroPulsado("1"))
boton1.grid(row=5,column=1)
boton2=Button(miFrame,text="2",font=tamanoFuente,bg=color_botones,width=ancho_botones,height=largo_botones,relief=borde_boton,bd=tamanoBorde,command=lambda:numeroPulsado("2"))
boton2.grid(row=5,column=2)
boton3=Button(miFrame,text="3",font=tamanoFuente,bg=color_botones,width=ancho_botones,height=largo_botones,relief=borde_boton,bd=tamanoBorde,command=lambda:numeroPulsado("3"))
boton3.grid(row=5,column=3)
botonResta=Button(miFrame,text="-",font=tamanoFuente,bg=color_botones,width=ancho_botones,height=largo_botones,relief=borde_boton,bd=tamanoBorde,command=lambda:resta(numeroPantalla.get()))
botonResta.grid(row=5,column=4)

#-----------------Botones inferiores-----Fila 6--------------

botonComa=Button(miFrame,text=".",font=tamanoFuente,bg=color_botones,width=ancho_botones,height=largo_botones,relief=borde_boton,bd=tamanoBorde,command=lambda:numeroPulsado("."))
botonComa.grid(row=6,column=1)
boton0=Button(miFrame,text="0",font=tamanoFuente,bg=color_botones,width=ancho_botones,height=largo_botones,relief=borde_boton,bd=tamanoBorde,command=lambda:numeroPulsado("0"))
boton0.grid(row=6,column=2)
boton00=Button(miFrame,text="00",font=tamanoFuente,bg=color_botones,width=ancho_botones,height=largo_botones,relief=borde_boton,bd=tamanoBorde,command=lambda:numeroPulsado("00"))
boton00.grid(row=6,column=3)
botonSuma=Button(miFrame,text="+",font=tamanoFuente,bg=color_botones,width=ancho_botones,height=largo_botones,relief=borde_boton,bd=tamanoBorde,command=lambda:suma(numeroPantalla.get()))
botonSuma.grid(row=6,column=4)

#-------------
raiz.mainloop()